pipeline
{
    agent any
    stages
    { 
        stage('Testing & Analysis')
        {
            steps
            {
                sh 'nosetests --with-xunit --all-modules --traverse-namespace --with-coverage --cover-package=project1 --cover-inclusive'
            }
        }
        stage('Code Quality Check')
        {
            steps
            {
                sh 'pylint -f parseable -d I0011,R0801 project1 | tee pylint.log'
            }
        }
        stage('random stage')
        {
            steps
            {
                sh 'python -m coverage xml --include=project1*'
                sh 'python -m coverage html --include=project1*'
                sh 'pdoc3 --force --html project1/'
                sh '7z a cvg-results.zip htmlcov/*'
                sh '7z a auto-doc.zip html/project1/*'
            }
        }
        stage('Publishing reports')
        {
            steps
            {
                publishCoverage adapters: [antPath('coverage.xml')], sourceFileResolver: sourceFiles('NEVER_STORE')
                archiveArtifacts 'auto-doc.zip, cvg-results.zip'
                recordIssues(tools: [pyLint()])
            }
        }
        stage('Docker Build Stage')
        {
            steps
            {
                sh 'docker build -t myapp_image .'
            }
        }
        stage('Final stage (Deploying Flask App)')
        {
            steps
            {
                sh 'docker run -d -p 5000:5000 myapp_image'
            }
        }
    }
    post
    {
        always
        {
            junit 'nosetests.xml'
        }
    }
}